package ru.dbotthepony.mc.otm.menu.slot;

import net.minecraft.world.Container;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import ru.dbotthepony.mc.otm.container.MatteryContainer;

// Just a sign that this slot needs auto draw
public class MatterySlot extends Slot {
	public boolean auto_bg;

	public MatterySlot(Container p_40223_, int index, int x, int y, boolean auto_bg) {
		super(p_40223_, index, x, y);
		this.auto_bg = auto_bg;
	}

	public MatterySlot(Container p_40223_, int index, int x, int y) {
		this(p_40223_, index, x, y, true);
	}

	private ItemStack last_stack;

	@Override
	public ItemStack getItem() {
		var get = super.getItem();
		last_stack = get.copy();
		return get;
	}

	@Override
	public void setChanged() {
		if (container instanceof MatteryContainer container1) {
			ItemStack old = last_stack.copy();
			container1.setChanged(getSlotIndex(), super.getItem(), old);
		} else {
			super.setChanged();
		}
	}

	@Override
	public void set(ItemStack p_40240_) {
		if (container instanceof MatteryContainer container1) {
			ItemStack old = container1.getItem(getSlotIndex()).copy();
			container1.startIgnore();
			container1.setItem(getSlotIndex(), p_40240_);
			container1.stopIgnore();
			container1.setChanged(getSlotIndex(), p_40240_, old);
		} else {
			super.set(p_40240_);
		}
	}
}
