package ru.dbotthepony.mc.otm.menu.widget;

import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TranslatableComponent;
import ru.dbotthepony.mc.otm.capability.IMatterHandler;
import ru.dbotthepony.mc.otm.menu.FormattingHelper;
import ru.dbotthepony.mc.otm.menu.MatteryMenu;
import ru.dbotthepony.mc.otm.screen.MatteryScreen;

import java.math.BigDecimal;
import java.util.List;
import java.util.function.Supplier;

public class MatterLevelWidget<T extends MatteryMenu> extends StorageGaugeWidget<T> {
	public MatterLevelWidget(T menu, int x, int y, IMatterHandler capability) {
		super(menu, x, y, capability::getStoredMatter, capability::getMaxStoredMatter);
	}

	public MatterLevelWidget(T menu, int x, int y) {
		super(menu, x, y);
	}

	public MatterLevelWidget(T menu, int x, int y, Supplier<BigDecimal> value_supplier, Supplier<BigDecimal> max_value_supplier) {
		super(menu, x, y, value_supplier, max_value_supplier);
	}

	@Override
	public int getImageWidth() {
		return 9;
	}

	@Override
	public int getImageHeight() {
		return 48;
	}

	@Override
	public int getImageX() {
		return 0;
	}

	@Override
	public int getImageY() {
		return 0;
	}

	@Override
	public boolean renderTooltip(MatteryScreen<T> screen, PoseStack pose, int local_x, int local_y, int mouse_x, int mouse_y) {
		if (is_hovered) {
			List<Component> text = List.of(
				new TranslatableComponent("otm.gui.matter.percentage_level", String.format("%.2f", getLevel() * 100d)),
				FormattingHelper.formatMatterLevel(value_container.getDecimal(), max_value_container.getDecimal())
			);

			screen.renderComponentTooltip(pose, text, mouse_x, mouse_y);

			return true;
		}

		return false;
	}
}
