package ru.dbotthepony.mc.otm.network;

import net.minecraft.resources.ResourceLocation;
import net.minecraftforge.fmllegacy.network.NetworkDirection;
import net.minecraftforge.fmllegacy.network.NetworkRegistry;
import net.minecraftforge.fmllegacy.network.simple.SimpleChannel;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;

import java.util.Optional;

public class MatteryNetworking {
	private static final String PROTOCOL_VERSION = "1";

	private static int next_network_id = 0;

	public static final SimpleChannel CHANNEL = NetworkRegistry.newSimpleChannel(
		new ResourceLocation(OverdriveThatMatters.MOD_ID, "main"),
		() -> PROTOCOL_VERSION,
		PROTOCOL_VERSION::equals,
		PROTOCOL_VERSION::equals
	);

	public static void register() {
		CHANNEL.registerMessage(
			next_network_id++,
			AndroidCapabilityChangePacket.class,
			AndroidCapabilityChangePacket::encodeNetwork,
			AndroidCapabilityChangePacket::decodeNetwork,
			AndroidCapabilityChangePacket::handleMessage,
			Optional.of(NetworkDirection.PLAY_TO_CLIENT)
		);

		CHANNEL.registerMessage(
			next_network_id++,
			PatternGridPacket.class,
			PatternGridPacket::write,
			PatternGridPacket::read,
			PatternGridPacket::play,
			Optional.of(NetworkDirection.PLAY_TO_CLIENT)
		);

		CHANNEL.registerMessage(
			next_network_id++,
			PatternReplicationRequestPacket.class,
			PatternReplicationRequestPacket::write,
			PatternReplicationRequestPacket::read,
			PatternReplicationRequestPacket::play,
			Optional.of(NetworkDirection.PLAY_TO_SERVER)
		);
	}
}
